]> git.ipfire.org Git - people/ms/u-boot.git/blob - MAKEALL
Merge branch 'u-boot-ti/master' into 'u-boot-arm/master'
[people/ms/u-boot.git] / MAKEALL
1 #!/bin/bash
2 # Tool mainly for U-Boot Quality Assurance: build one or more board
3 # configurations with minimal verbosity, showing only warnings and
4 # errors.
5
6 usage()
7 {
8 # if exiting with 0, write to stdout, else write to stderr
9 local ret=${1:-0}
10 [ "${ret}" -eq 1 ] && exec 1>&2
11 cat <<-EOF
12 Usage: MAKEALL [options] [--] [boards-to-build]
13
14 Options:
15 -a ARCH, --arch ARCH Build all boards with arch ARCH
16 -c CPU, --cpu CPU Build all boards with cpu CPU
17 -v VENDOR, --vendor VENDOR Build all boards with vendor VENDOR
18 -s SOC, --soc SOC Build all boards with soc SOC
19 -l, --list List all targets to be built
20 -m, --maintainers List all targets and maintainer email
21 -M, --mails List all targets and all affilated emails
22 -C, --check Enable build checking
23 -n, --continue Continue (skip boards already built)
24 -r, --rebuild-errors Rebuild any boards that errored
25 -h, --help This help output
26
27 Selections by these options are logically ANDed; if the same option
28 is used repeatedly, such selections are ORed. So "-v FOO -v BAR"
29 will select all configurations where the vendor is either FOO or
30 BAR. Any additional arguments specified on the command line are
31 always build additionally. See the boards.cfg file for more info.
32
33 If no boards are specified, then the default is "powerpc".
34
35 Environment variables:
36 BUILD_NCPUS number of parallel make jobs (default: auto)
37 CROSS_COMPILE cross-compiler toolchain prefix (default: "")
38 CROSS_COMPILE_<ARCH> cross-compiler toolchain prefix for
39 architecture "ARCH". Substitute "ARCH" for any
40 supported architecture (default: "")
41 MAKEALL_LOGDIR output all logs to here (default: ./LOG/)
42 BUILD_DIR output build directory (default: ./)
43 BUILD_NBUILDS number of parallel targets (default: 1)
44
45 Examples:
46 - build all Power Architecture boards:
47 MAKEALL -a powerpc
48 MAKEALL --arch powerpc
49 MAKEALL powerpc
50 - build all PowerPC boards manufactured by vendor "esd":
51 MAKEALL -a powerpc -v esd
52 - build all PowerPC boards manufactured either by "keymile" or "siemens":
53 MAKEALL -a powerpc -v keymile -v siemens
54 - build all Freescale boards with MPC83xx CPUs, plus all 4xx boards:
55 MAKEALL -c mpc83xx -v freescale 4xx
56 EOF
57 exit ${ret}
58 }
59
60 SHORT_OPTS="ha:c:v:s:lmMCnr"
61 LONG_OPTS="help,arch:,cpu:,vendor:,soc:,list,maintainers,mails,check,continue,rebuild-errors"
62
63 # Option processing based on util-linux-2.13/getopt-parse.bash
64
65 # Note that we use `"$@"' to let each command-line parameter expand to a
66 # separate word. The quotes around `$@' are essential!
67 # We need TEMP as the `eval set --' would nuke the return value of
68 # getopt.
69 TEMP=`getopt -o ${SHORT_OPTS} --long ${LONG_OPTS} \
70 -n 'MAKEALL' -- "$@"`
71
72 [ $? != 0 ] && usage 1
73
74 # Note the quotes around `$TEMP': they are essential!
75 eval set -- "$TEMP"
76
77 SELECTED=''
78 ONLY_LIST=''
79 PRINT_MAINTS=''
80 MAINTAINERS_ONLY=''
81 CONTINUE=''
82 REBUILD_ERRORS=''
83
84 while true ; do
85 case "$1" in
86 -a|--arch)
87 # echo "Option ARCH: argument \`$2'"
88 if [ "$opt_a" ] ; then
89 opt_a="${opt_a%)} || \$2 == \"$2\")"
90 else
91 opt_a="(\$2 == \"$2\")"
92 fi
93 SELECTED='y'
94 shift 2 ;;
95 -c|--cpu)
96 # echo "Option CPU: argument \`$2'"
97 if [ "$opt_c" ] ; then
98 opt_c="${opt_c%)} || \$3 == \"$2\" || \$3 ~ /$2:/)"
99 else
100 opt_c="(\$3 == \"$2\" || \$3 ~ /$2:/)"
101 fi
102 SELECTED='y'
103 shift 2 ;;
104 -s|--soc)
105 # echo "Option SoC: argument \`$2'"
106 if [ "$opt_s" ] ; then
107 opt_s="${opt_s%)} || \$6 == \"$2\" || \$6 ~ /$2/)"
108 else
109 opt_s="(\$6 == \"$2\" || \$6 ~ /$2/)"
110 fi
111 SELECTED='y'
112 shift 2 ;;
113 -v|--vendor)
114 # echo "Option VENDOR: argument \`$2'"
115 if [ "$opt_v" ] ; then
116 opt_v="${opt_v%)} || \$5 == \"$2\")"
117 else
118 opt_v="(\$5 == \"$2\")"
119 fi
120 SELECTED='y'
121 shift 2 ;;
122 -C|--check)
123 CHECK='C=1'
124 shift ;;
125 -n|--continue)
126 CONTINUE='y'
127 shift ;;
128 -r|--rebuild-errors)
129 REBUILD_ERRORS='y'
130 shift ;;
131 -l|--list)
132 ONLY_LIST='y'
133 shift ;;
134 -m|--maintainers)
135 ONLY_LIST='y'
136 PRINT_MAINTS='y'
137 MAINTAINERS_ONLY='y'
138 shift ;;
139 -M|--mails)
140 ONLY_LIST='y'
141 PRINT_MAINTS='y'
142 shift ;;
143 -h|--help)
144 usage ;;
145 --)
146 shift ; break ;;
147 *)
148 echo "Internal error!" >&2 ; exit 1 ;;
149 esac
150 done
151 # echo "Remaining arguments:"
152 # for arg do echo '--> '"\`$arg'" ; done
153
154 FILTER="\$1 !~ /^#/"
155 [ "$opt_a" ] && FILTER="${FILTER} && $opt_a"
156 [ "$opt_c" ] && FILTER="${FILTER} && $opt_c"
157 [ "$opt_s" ] && FILTER="${FILTER} && $opt_s"
158 [ "$opt_v" ] && FILTER="${FILTER} && $opt_v"
159
160 if [ "$SELECTED" ] ; then
161 SELECTED=$(awk '('"$FILTER"') { print $1 }' boards.cfg)
162
163 # Make sure some boards from boards.cfg are actually found
164 if [ -z "$SELECTED" ] ; then
165 echo "Error: No boards selected, invalid arguments"
166 exit 1
167 fi
168 fi
169
170 #########################################################################
171
172 # Print statistics when we exit
173 trap exit 1 2 3 15
174 trap print_stats 0
175
176 # Determine number of CPU cores if no default was set
177 : ${BUILD_NCPUS:="`getconf _NPROCESSORS_ONLN`"}
178
179 if [ "$BUILD_NCPUS" -gt 1 ]
180 then
181 JOBS="-j $((BUILD_NCPUS + 1))"
182 else
183 JOBS=""
184 fi
185
186 if [ "${MAKEALL_LOGDIR}" ] ; then
187 LOG_DIR=${MAKEALL_LOGDIR}
188 else
189 LOG_DIR="LOG"
190 fi
191
192 : ${BUILD_NBUILDS:=1}
193 BUILD_MANY=0
194
195 if [ "${BUILD_NBUILDS}" -gt 1 ] ; then
196 BUILD_MANY=1
197 : ${BUILD_DIR:=./build}
198 mkdir -p "${BUILD_DIR}/ERR"
199 find "${BUILD_DIR}/ERR/" -type f -exec rm -f {} +
200 fi
201
202 : ${BUILD_DIR:=.}
203
204 OUTPUT_PREFIX="${BUILD_DIR}"
205
206 [ -d ${LOG_DIR} ] || mkdir "${LOG_DIR}" || exit 1
207 if [ "$CONTINUE" != 'y' -a "$REBUILD_ERRORS" != 'y' ] ; then
208 find "${LOG_DIR}/" -type f -exec rm -f {} +
209 fi
210
211 LIST=""
212
213 # Keep track of the number of builds and errors
214 ERR_CNT=0
215 ERR_LIST=""
216 WRN_CNT=0
217 WRN_LIST=""
218 TOTAL_CNT=0
219 SKIP_CNT=0
220 CURRENT_CNT=0
221 OLDEST_IDX=1
222 RC=0
223
224 # Helper funcs for parsing boards.cfg
225 boards_by_field()
226 {
227 FS="[ \t]+"
228 [ -n "$3" ] && FS="$3"
229 awk \
230 -v field="$1" \
231 -v select="$2" \
232 -F "$FS" \
233 '($1 !~ /^#/ && $field == select) { print $1 }' \
234 boards.cfg
235 }
236 boards_by_arch() { boards_by_field 2 "$@" ; }
237 boards_by_cpu() { boards_by_field 3 "$@" "[: \t]+" ; }
238 boards_by_soc() { boards_by_field 6 "$@" ; }
239
240 #########################################################################
241 ## MPC5xx Systems
242 #########################################################################
243
244 LIST_5xx="$(boards_by_cpu mpc5xx)"
245
246 #########################################################################
247 ## MPC5xxx Systems
248 #########################################################################
249
250 LIST_5xxx="$(boards_by_cpu mpc5xxx)"
251
252 #########################################################################
253 ## MPC512x Systems
254 #########################################################################
255
256 LIST_512x="$(boards_by_cpu mpc512x)"
257
258 #########################################################################
259 ## MPC8xx Systems
260 #########################################################################
261
262 LIST_8xx="$(boards_by_cpu mpc8xx)"
263
264 #########################################################################
265 ## PPC4xx Systems
266 #########################################################################
267
268 LIST_4xx="$(boards_by_cpu ppc4xx)"
269
270 #########################################################################
271 ## MPC824x Systems
272 #########################################################################
273
274 LIST_824x="$(boards_by_cpu mpc824x)"
275
276 #########################################################################
277 ## MPC8260 Systems (includes 8250, 8255 etc.)
278 #########################################################################
279
280 LIST_8260="$(boards_by_cpu mpc8260)"
281
282 #########################################################################
283 ## MPC83xx Systems (includes 8349, etc.)
284 #########################################################################
285
286 LIST_83xx="$(boards_by_cpu mpc83xx)"
287
288 #########################################################################
289 ## MPC85xx Systems (includes 8540, 8560 etc.)
290 #########################################################################
291
292 LIST_85xx="$(boards_by_cpu mpc85xx)"
293
294 #########################################################################
295 ## MPC86xx Systems
296 #########################################################################
297
298 LIST_86xx="$(boards_by_cpu mpc86xx)"
299
300 #########################################################################
301 ## 74xx/7xx Systems
302 #########################################################################
303
304 LIST_74xx_7xx="$(boards_by_cpu 74xx_7xx)"
305
306 #########################################################################
307 ## PowerPC groups
308 #########################################################################
309
310 LIST_TSEC=" \
311 ${LIST_83xx} \
312 ${LIST_85xx} \
313 ${LIST_86xx} \
314 "
315
316 LIST_powerpc=" \
317 ${LIST_5xx} \
318 ${LIST_512x} \
319 ${LIST_5xxx} \
320 ${LIST_8xx} \
321 ${LIST_824x} \
322 ${LIST_8260} \
323 ${LIST_83xx} \
324 ${LIST_85xx} \
325 ${LIST_86xx} \
326 ${LIST_4xx} \
327 ${LIST_74xx_7xx}\
328 "
329
330 # Alias "ppc" -> "powerpc" to not break compatibility with older scripts
331 # still using "ppc" instead of "powerpc"
332 LIST_ppc=" \
333 ${LIST_powerpc} \
334 "
335
336 #########################################################################
337 ## StrongARM Systems
338 #########################################################################
339
340 LIST_SA="$(boards_by_cpu sa1100)"
341
342 #########################################################################
343 ## ARM7 Systems
344 #########################################################################
345
346 LIST_ARM7="$(boards_by_cpu arm720t)"
347
348 #########################################################################
349 ## ARM9 Systems
350 #########################################################################
351
352 LIST_ARM9="$(boards_by_cpu arm920t) \
353 $(boards_by_cpu arm926ejs) \
354 $(boards_by_cpu arm925t) \
355 $(boards_by_cpu arm946es) \
356 "
357
358 #########################################################################
359 ## ARM11 Systems
360 #########################################################################
361 LIST_ARM11="$(boards_by_cpu arm1136) \
362 $(boards_by_cpu arm1176) \
363 "
364
365 #########################################################################
366 ## ARMV7 Systems
367 #########################################################################
368
369 LIST_ARMV7="$(boards_by_cpu armv7)"
370
371 #########################################################################
372 ## AT91 Systems
373 #########################################################################
374
375 LIST_at91="$(boards_by_soc at91)"
376
377 #########################################################################
378 ## Xscale Systems
379 #########################################################################
380
381 LIST_pxa="$(boards_by_cpu pxa)"
382
383 LIST_ixp="$(boards_by_cpu ixp)"
384
385 #########################################################################
386 ## SPEAr Systems
387 #########################################################################
388
389 LIST_spear="$(boards_by_soc spear)"
390
391 #########################################################################
392 ## ARM groups
393 #########################################################################
394
395 LIST_arm="$(boards_by_arch arm)"
396
397 #########################################################################
398 ## MIPS Systems (default = big endian)
399 #########################################################################
400
401 LIST_mips4kc=" \
402 incaip \
403 incaip_100MHz \
404 incaip_133MHz \
405 incaip_150MHz \
406 qemu_mips \
407 vct_platinum \
408 vct_platinum_small \
409 vct_platinum_onenand \
410 vct_platinum_onenand_small \
411 vct_platinumavc \
412 vct_platinumavc_small \
413 vct_platinumavc_onenand \
414 vct_platinumavc_onenand_small \
415 vct_premium \
416 vct_premium_small \
417 vct_premium_onenand \
418 vct_premium_onenand_small \
419 "
420
421 LIST_au1xx0=" \
422 dbau1000 \
423 dbau1100 \
424 dbau1500 \
425 dbau1550 \
426 "
427
428 LIST_mips=" \
429 ${LIST_mips4kc} \
430 ${LIST_mips5kc} \
431 ${LIST_au1xx0} \
432 "
433
434 #########################################################################
435 ## MIPS Systems (little endian)
436 #########################################################################
437
438 LIST_xburst_el=" \
439 qi_lb60 \
440 "
441
442 LIST_au1xx0_el=" \
443 dbau1550_el \
444 pb1000 \
445 "
446 LIST_mips_el=" \
447 ${LIST_xburst_el} \
448 ${LIST_au1xx0_el} \
449 "
450 #########################################################################
451 ## OpenRISC Systems
452 #########################################################################
453
454 LIST_openrisc="$(boards_by_arch openrisc)"
455
456 #########################################################################
457 ## x86 Systems
458 #########################################################################
459
460 LIST_x86="$(boards_by_arch x86)"
461
462 #########################################################################
463 ## Nios-II Systems
464 #########################################################################
465
466 LIST_nios2="$(boards_by_arch nios2)"
467
468 #########################################################################
469 ## MicroBlaze Systems
470 #########################################################################
471
472 LIST_microblaze="$(boards_by_arch microblaze)"
473
474 #########################################################################
475 ## ColdFire Systems
476 #########################################################################
477
478 LIST_m68k="$(boards_by_arch m68k)"
479 LIST_coldfire=${LIST_m68k}
480
481 #########################################################################
482 ## AVR32 Systems
483 #########################################################################
484
485 LIST_avr32="$(boards_by_arch avr32)"
486
487 #########################################################################
488 ## Blackfin Systems
489 #########################################################################
490
491 LIST_blackfin="$(boards_by_arch blackfin)"
492
493 #########################################################################
494 ## SH Systems
495 #########################################################################
496
497 LIST_sh2="$(boards_by_cpu sh2)"
498 LIST_sh3="$(boards_by_cpu sh3)"
499 LIST_sh4="$(boards_by_cpu sh4)"
500
501 LIST_sh="$(boards_by_arch sh)"
502
503 #########################################################################
504 ## SPARC Systems
505 #########################################################################
506
507 LIST_sparc="$(boards_by_arch sparc)"
508
509 #########################################################################
510 ## NDS32 Systems
511 #########################################################################
512
513 LIST_nds32="$(boards_by_arch nds32)"
514
515 #-----------------------------------------------------------------------
516
517 get_target_location() {
518 local target=$1
519 local BOARD_NAME=""
520 local CONFIG_NAME=""
521 local board=""
522 local vendor=""
523
524 # Automatic mode
525 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
526
527 if [ -z "${line}" ] ; then echo "" ; return ; fi
528
529 set ${line}
530
531 # add default board name if needed
532 [ $# = 3 ] && set ${line} ${1}
533
534 CONFIG_NAME="${1%_config}"
535
536 [ "${BOARD_NAME}" ] || BOARD_NAME="${1%_config}"
537
538 if [ "$4" = "-" ] ; then
539 board=${BOARD_NAME}
540 else
541 board="$4"
542 fi
543
544 [ $# -gt 4 ] && [ "$5" != "-" ] && vendor="$5"
545 [ $# -gt 6 ] && [ "$7" != "-" ] && {
546 tmp="${7%:*}"
547 if [ "$tmp" ] ; then
548 CONFIG_NAME="$tmp"
549 fi
550 }
551
552 # Assign board directory to BOARDIR variable
553 if [ -z "${vendor}" ] ; then
554 BOARDDIR=${board}
555 else
556 BOARDDIR=${vendor}/${board}
557 fi
558
559 echo "${CONFIG_NAME}:${BOARDDIR}"
560 }
561
562 get_target_maintainers() {
563 local name=`echo $1 | cut -d : -f 1`
564
565 if ! grep -qsi "[[:blank:]]${name}[[:blank:]]" MAINTAINERS ; then
566 echo ""
567 return ;
568 fi
569
570 local line=`tac MAINTAINERS | grep -ni "[[:blank:]]${name}[[:blank:]]" | cut -d : -f 1`
571 local mail=`tac MAINTAINERS | tail -n +${line} | \
572 sed -n ":start /.*@.*/ { b mail } ; n ; b start ; :mail /.*@.*/ { p ; n ; b mail } ; q" | \
573 sed "s/^.*<//;s/>.*$//"`
574 echo "$mail"
575 }
576
577 get_target_arch() {
578 local target=$1
579
580 # Automatic mode
581 local line=`egrep -i "^[[:space:]]*${target}[[:space:]]" boards.cfg`
582
583 if [ -z "${line}" ] ; then echo "" ; return ; fi
584
585 set ${line}
586 echo "$2"
587 }
588
589 list_target() {
590 if [ "$PRINT_MAINTS" != 'y' ] ; then
591 echo "$1"
592 return
593 fi
594
595 echo -n "$1:"
596
597 local loc=`get_target_location $1`
598
599 if [ -z "${loc}" ] ; then echo "ERROR" ; return ; fi
600
601 local maintainers_result=`get_target_maintainers ${loc} | tr " " "\n"`
602
603 if [ "$MAINTAINERS_ONLY" != 'y' ] ; then
604
605 local dir=`echo ${loc} | cut -d ":" -f 2`
606 local cfg=`echo ${loc} | cut -d ":" -f 1`
607 local git_result=`git log --format=%aE board/${dir} \
608 include/configs/${cfg}.h | grep "@"`
609 local git_result_recent=`echo ${git_result} | tr " " "\n" | \
610 head -n 3`
611 local git_result_top=`echo ${git_result} | tr " " "\n" | \
612 sort | uniq -c | sort -nr | head -n 3 | \
613 sed "s/^ \+[0-9]\+ \+//"`
614
615 echo -e "$git_result_recent\n$git_result_top\n$maintainers_result" | \
616 sort -u | tr "\n" " " | sed "s/ $//" ;
617 else
618 echo -e "$maintainers_result" | sort -u | tr "\n" " " | \
619 sed "s/ $//" ;
620 fi
621
622 echo ""
623 }
624
625 # Each finished build will have a file called ${donep}${n},
626 # where n is the index of the build. Each build
627 # we've already noted as finished will have ${skipp}${n}.
628 # The code managing the build process will use this information
629 # to ensure that only BUILD_NBUILDS builds are in flight at once
630 donep="${LOG_DIR}/._done_"
631 skipp="${LOG_DIR}/._skip_"
632
633 build_target_killed() {
634 echo "Aborted $target build."
635 # Remove the logs for this board since it was aborted
636 rm -f ${LOG_DIR}/$target.MAKELOG ${LOG_DIR}/$target.ERR
637 exit
638 }
639
640 build_target() {
641 target=$1
642 build_idx=$2
643
644 if [ "$ONLY_LIST" == 'y' ] ; then
645 list_target ${target}
646 return
647 fi
648
649 if [ $BUILD_MANY == 1 ] ; then
650 output_dir="${OUTPUT_PREFIX}/${target}"
651 mkdir -p "${output_dir}"
652 trap build_target_killed TERM
653 else
654 output_dir="${OUTPUT_PREFIX}"
655 fi
656
657 export BUILD_DIR="${output_dir}"
658
659 target_arch=$(get_target_arch ${target})
660 eval cross_toolchain=\$CROSS_COMPILE_`echo $target_arch | tr '[:lower:]' '[:upper:]'`
661 if [ "${cross_toolchain}" ] ; then
662 MAKE="make CROSS_COMPILE=${cross_toolchain}"
663 elif [ "${CROSS_COMPILE}" ] ; then
664 MAKE="make CROSS_COMPILE=${CROSS_COMPILE}"
665 else
666 MAKE=make
667 fi
668
669 ${MAKE} distclean >/dev/null
670 ${MAKE} -s ${target}_config
671
672 ${MAKE} ${JOBS} ${CHECK} all \
673 >${LOG_DIR}/$target.MAKELOG 2> ${LOG_DIR}/$target.ERR
674
675 # Check for 'make' errors
676 if [ ${PIPESTATUS[0]} -ne 0 ] ; then
677 RC=1
678 fi
679
680 if [ $BUILD_MANY == 1 ] ; then
681 trap - TERM
682
683 ${MAKE} -s tidy
684
685 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
686 cp ${LOG_DIR}/${target}.ERR ${OUTPUT_PREFIX}/ERR/${target}
687 else
688 rm ${LOG_DIR}/${target}.ERR
689 fi
690 else
691 if [ -s ${LOG_DIR}/${target}.ERR ] ; then
692 if grep -iw error ${LOG_DIR}/${target}.ERR ; then
693 : $(( ERR_CNT += 1 ))
694 ERR_LIST="${ERR_LIST} $target"
695 else
696 : $(( WRN_CNT += 1 ))
697 WRN_LIST="${WRN_LIST} $target"
698 fi
699 else
700 rm ${LOG_DIR}/${target}.ERR
701 fi
702 fi
703
704 OBJS=${output_dir}/u-boot
705 if [ -e ${output_dir}/spl/u-boot-spl ]; then
706 OBJS="${OBJS} ${output_dir}/spl/u-boot-spl"
707 fi
708
709 ${CROSS_COMPILE}size ${OBJS} | tee -a ${LOG_DIR}/$target.MAKELOG
710
711 [ -e "${LOG_DIR}/${target}.ERR" ] && cat "${LOG_DIR}/${target}.ERR"
712
713 touch "${donep}${build_idx}"
714 }
715
716 manage_builds() {
717 search_idx=${OLDEST_IDX}
718 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
719
720 while true; do
721 if [ -e "${donep}${search_idx}" ] ; then
722 : $(( CURRENT_CNT-- ))
723 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
724 : $(( OLDEST_IDX++ ))
725
726 # Only want to count it once
727 rm -f "${donep}${search_idx}"
728 touch "${skipp}${search_idx}"
729 elif [ -e "${skipp}${search_idx}" ] ; then
730 [ ${OLDEST_IDX} -eq ${search_idx} ] &&
731 : $(( OLDEST_IDX++ ))
732 fi
733 : $(( search_idx++ ))
734 if [ ${search_idx} -gt ${TOTAL_CNT} ] ; then
735 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
736 search_idx=${OLDEST_IDX}
737 sleep 1
738 else
739 break
740 fi
741 fi
742 done
743 }
744
745 build_targets() {
746 for t in "$@" ; do
747 # If a LIST_xxx var exists, use it. But avoid variable
748 # expansion in the eval when a board name contains certain
749 # characters that the shell interprets.
750 case ${t} in
751 *[-+=]*) list= ;;
752 *) list=$(eval echo '${LIST_'$t'}') ;;
753 esac
754 if [ -n "${list}" ] ; then
755 build_targets ${list}
756 else
757 : $((TOTAL_CNT += 1))
758 : $((CURRENT_CNT += 1))
759 rm -f "${donep}${TOTAL_CNT}"
760 rm -f "${skipp}${TOTAL_CNT}"
761 if [ "$CONTINUE" = 'y' -a -e ${LOG_DIR}/$t.MAKELOG ] ; then
762 : $((SKIP_CNT += 1))
763 touch "${donep}${TOTAL_CNT}"
764 elif [ "$REBUILD_ERRORS" = 'y' -a ! -e ${LOG_DIR}/$t.ERR ] ; then
765 : $((SKIP_CNT += 1))
766 touch "${donep}${TOTAL_CNT}"
767 else
768 if [ $BUILD_MANY == 1 ] ; then
769 build_target ${t} ${TOTAL_CNT} &
770 else
771 CUR_TGT="${t}"
772 build_target ${t} ${TOTAL_CNT}
773 CUR_TGT=''
774 fi
775 fi
776 fi
777
778 # We maintain a running count of all the builds we have done.
779 # Each finished build will have a file called ${donep}${n},
780 # where n is the index of the build. Each build
781 # we've already noted as finished will have ${skipp}${n}.
782 # We track the current index via TOTAL_CNT, and the oldest
783 # index. When we exceed the maximum number of parallel builds,
784 # We look from oldest to current for builds that have completed,
785 # and update the current count and oldest index as appropriate.
786 # If we've gone through the entire list, wait a second, and
787 # reprocess the entire list until we find a build that has
788 # completed
789 if [ ${CURRENT_CNT} -ge ${BUILD_NBUILDS} ] ; then
790 manage_builds
791 fi
792 done
793 }
794
795 #-----------------------------------------------------------------------
796
797 kill_children() {
798 local OS=$(uname -s)
799 local children=""
800 case "${OS}" in
801 "Darwin")
802 # Mac OS X is known to have BSD style ps
803 local pgid=$(ps -p $$ -o pgid | sed -e "/PGID/d")
804 children=$(ps -g $pgid -o pid | sed -e "/PID\|$$\|$pgid/d")
805 ;;
806 *)
807 # everything else tries the GNU style
808 local pgid=$(ps -p $$ --no-headers -o "%r" | tr -d ' ')
809 children=$(pgrep -g $pgid | sed -e "/$$\|$pgid/d")
810 ;;
811 esac
812
813 kill $children 2> /dev/null
814 wait $children 2> /dev/null
815
816 exit
817 }
818
819 print_stats() {
820 if [ "$ONLY_LIST" == 'y' ] ; then return ; fi
821
822 # Only count boards that completed
823 : $((TOTAL_CNT = `find ${skipp}* 2> /dev/null | wc -l`))
824
825 rm -f ${donep}* ${skipp}*
826
827 if [ $BUILD_MANY == 1 ] && [ -e "${OUTPUT_PREFIX}/ERR" ] ; then
828 ERR_LIST=`grep -riwl error ${OUTPUT_PREFIX}/ERR/`
829 ERR_LIST=`for f in $ERR_LIST ; do echo -n " $(basename $f)" ; done`
830 ERR_CNT=`echo $ERR_LIST | wc -w | awk '{print $1}'`
831 WRN_LIST=`grep -riwL error ${OUTPUT_PREFIX}/ERR/`
832 WRN_LIST=`for f in $WRN_LIST ; do echo -n " $(basename $f)" ; done`
833 WRN_CNT=`echo $WRN_LIST | wc -w | awk '{print $1}'`
834 else
835 # Remove the logs for any board that was interrupted
836 rm -f ${LOG_DIR}/${CUR_TGT}.MAKELOG ${LOG_DIR}/${CUR_TGT}.ERR
837 fi
838
839 : $((TOTAL_CNT -= ${SKIP_CNT}))
840 echo ""
841 echo "--------------------- SUMMARY ----------------------------"
842 if [ "$CONTINUE" = 'y' -o "$REBUILD_ERRORS" = 'y' ] ; then
843 echo "Boards skipped: ${SKIP_CNT}"
844 fi
845 echo "Boards compiled: ${TOTAL_CNT}"
846 if [ ${ERR_CNT} -gt 0 ] ; then
847 echo "Boards with errors: ${ERR_CNT} (${ERR_LIST} )"
848 fi
849 if [ ${WRN_CNT} -gt 0 ] ; then
850 echo "Boards with warnings but no errors: ${WRN_CNT} (${WRN_LIST} )"
851 fi
852 echo "----------------------------------------------------------"
853
854 if [ $BUILD_MANY == 1 ] ; then
855 kill_children
856 fi
857
858 exit $RC
859 }
860
861 #-----------------------------------------------------------------------
862
863 # Build target groups selected by options, plus any command line args
864 set -- ${SELECTED} "$@"
865 # run PowerPC by default
866 [ $# = 0 ] && set -- powerpc
867 build_targets "$@"
868 wait